#ifndef CGAME
#define CGAME

#include "CCard.hpp"
#include "CPack.hpp"
#include "CPackDraw.hpp"
#include "set"


#define PackSize 5
class CGame
{
  protected:
		// member variables
	  long mMoney;
  	CPack* myPack;
	  CPack* allTheCards;
  	std::set<int> setOfUsedCards;

  private:
  	// member functions
  	void Init();
   
  public:
  	// exceptions
	  enum Exceptions 					 	 { GameOver };
  	// constructors
	  CGame()                  		 { this->Init(); }
  	CGame(long money)       		 { this->mMoney = money; this->Init(); }
  	~CGame()								 		 { delete this->myPack; delete this->allTheCards; }
		// get methods
  	long   getMoney() const	 		 { return this->mMoney; }
	  CPack* getPack() const   		 { return this->myPack; }
	  // set methods
  	void   setMoney(long money)	 { if (money<=0) throw GameOver; else mMoney = money; }
    // public functions
  	void Deal()									 { this->setOfUsedCards.clear(); this->DealAgain(); }
	  void DealAgain();        		 // later
  	void switchCards(int);			 // later
  	void sortCards();						 // later
};




void CGame::Init()
{
  allTheCards = new CPack(52);
	for (int number=0; number<13; number++)
	{
		for (int color=0; color<4; color++)
		{
			allTheCards->setElement(color*13+number, CCard(color, number));
		}
	}
	myPack = new CPack(PackSize);
	// Deal();
};


void CGame::DealAgain()
{
	for (int i=0; i<myPack->getNumberOfCards(); i++)
	{
		switchCards(i);
  }
};


void CGame::switchCards(int n)
{
	if (0<=n && n<PackSize)
	{
		int randomCard;
		for (randomCard=rand()%52; setOfUsedCards.count(randomCard)>=1; randomCard=rand()%52);
		myPack->setElement(n, allTheCards->getElement(randomCard));
		setOfUsedCards.insert(randomCard);
	}
};


void CGame::sortCards()
{
	int i, j;
 	for (i=0; i<PackSize-1; i++)
 	{
 		for (j=i+1; j<PackSize; j++)
 		{
 			if (myPack->getElement(i).getNumber()>myPack->getElement(j).getNumber())
 			{
 				CCard temp = myPack->getElement(i);
 				myPack->setElement(i, myPack->getElement(j));
 				myPack->setElement(j, temp);
			}
 		}
 	}
};


#endif
