#ifndef CPOKER
#define CPOKER

#include <stdio.h>

#include "CGame.hpp"
#include "CPokerParams.hpp"


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
enum	 table													 { Nothing, Pair, DoublePair, Drill, Row, FullHouse, Flush, Poker, RoyalFlush };
int		 multiplicity   [RoyalFlush+1] = { multiNothing, multiPair, multiDoublePair, multiDrill, multiRow, multiFullHouse, multiFlush, multiPoker, multiRoyalFlush };
string writeWinString [RoyalFlush+1] = { writeNothing, writePair, writeDoublePair, writeDrill, writeRow, writeFullHouse, writeFlush, writePoker, writeRoyalFlush };
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


class CPoker
{
	private:
		// member variables
		long   myMoney;
		CGame* pokerGame;
		
	public:
		// constructors
		CPoker(long m)			{ this->myMoney=m; pokerGame = new CGame(myMoney); }
		~CPoker()			 			{ }
		// functions
		bool  Play();				// returns true if you want to play again
	  table Win(CGame*);	// returns the winning samples given in the table
};




table CPoker::Win(CGame* game)
{
	unsigned int winNumber=1;
	// check out if it is Pair(s), Drill, both and Poker
	for (unsigned int i=0; i<game->getPack()->getNumberOfCards()-1; i++)
	{
		for (unsigned int j=i+1; j<game->getPack()->getNumberOfCards(); j++)
		{
		  if (game->getPack()->getElement(i).getNumber() == game->getPack()->getElement(j).getNumber())
		  {
			  winNumber++;
		  }
	  }
	}
	switch (winNumber)
	{
	  case 2: return Pair;				break;
	  case 3: return DoublePair;	break;
	  case 4: return Drill;				break;
	  case 6: return FullHouse;		break;
	  case 7: return Poker;				break;
	}

	unsigned int i;
	// if it is Flush
	for (i=0; (i<game->getPack()->getNumberOfCards()-1) && (game->getPack()->getElement(i).getColor() == game->getPack()->getElement(i+1).getColor()); i++);
	if (i==game->getPack()->getNumberOfCards()) winNumber*=10;
	// if it is Row
	(*game).sortCards();		// sortCards has to done well
	for (i=0; (i<game->getPack()->getNumberOfCards()-1) && (game->getPack()->getElement(i).getNumber() == game->getPack()->getElement(i+1).getNumber()+1); i++);
	if (i==game->getPack()->getNumberOfCards()) winNumber*=5;
	switch (winNumber)
	{
		case 5:  return Row;				break;
		case 10: return Flush;			break;
		case 50: return RoyalFlush;	break;
	}
	return Nothing;
};



bool CPoker::Play()
{
  char Again='y';
  while (Again=='1' || Again=='y' || Again=='Y' || Again=='i' || Again=='I')
  {
 		int noerror;
    pokerGame->Deal();
  	printf("\n\n");
  	long yourMoney = pokerGame->getMoney();
		printf("%s%li\n",  writeMoney, yourMoney);
		long yourBet = yourMoney+1;
		while (yourBet > yourMoney)
		{
			do
			{
			  fflush(stdin); // flush wrong input
				printf("%s", writeBet);
				noerror = scanf("%li", &yourBet);
				if (!noerror) printf("%s\n", writeError);
   		} while (!noerror);
			if (yourBet > yourMoney)
			{
	 			printf("%s\n", writeGreaterBet);
   		}
		}
		printf("\n");
		Draw(pokerGame->getPack());
		printf("\n");
		int yourSwitches;
		do
    {
      fflush(stdin);
    	printf("%s", writeSwitches);
			noerror = scanf("%i", &yourSwitches);
			if (noerror)
   		{
				if (yourSwitches < PackSize)
				{
					int yourSwitch;
					for (int i=0; i<yourSwitches; i++)
					{
						do
						{
						  fflush(stdin);
							printf("%s", writeToSwitch);
							noerror = scanf("%i", &yourSwitch);
							if (!noerror) printf("%s\n", writeError);
						} while (!noerror);
						pokerGame->switchCards(yourSwitch-1);
					}
				}
				else
				{
					pokerGame->DealAgain();
  			}
			}
			else printf("%s\n", writeError);
		} while (!noerror);
		printf("\n");
		Draw(pokerGame->getPack());
		printf("\n");
		table yourWin = Win(pokerGame);
		std::cout << writeWinString[yourWin] << endl;
		long yourWinMoney = yourBet*multiplicity[yourWin];
		printf("%s%li\n", writeWin, yourWinMoney);
		try
		{
		  pokerGame->setMoney(pokerGame->getMoney()-yourBet+yourWinMoney);
	  }
  	catch (...)
	  {
			printf("%s\n\n", writeLose);
  	  break;
	  }
	  do
	  {
	  	fflush(stdin);
 			printf("%s", writeDealAgain);
  		Again = getchar();
		} while (Again!='1' && Again!='y' && Again!='Y' && Again!='i' && Again!='I' && Again!='0' && Again!='n' && Again!='N');
	}
  std::cout << writeNewGame;
	do
  {
	 	fflush(stdin);
 		printf("%s", writeNewGame);
  	Again = getchar();
	} while (Again!='1' && Again!='y' && Again!='Y' && Again!='i' && Again!='I' && Again!='0' && Again!='n' && Again!='N');
  return (Again=='1' || Again=='y' || Again=='Y' || Again=='i' || Again=='I');
};

#endif
